<template>
	<div style="height: 100%" v-loading="loading">
		<el-row wrap v-if="raw">
			<el-col :xs="24"  >
				<el-input autosize :spellcheck="false" type="textarea" rows="15" v-model="contextRaw"></el-input>
			</el-col>
		</el-row>
		<el-table row-class-name="dialplan-exten-row" v-else :highlight-current-row="false" :data="context" height="100%"
			:span-method="agruparColumnaExten">
			<el-table-column width="150" prop="exten" align="center" label="Exten" v-if="showExten" >
				<template v-slot="{row}">
					<span v-if="readonly || row.app == 'include'">{{row.exten}}</span>
					<el-input v-else v-model="row.exten" size="mini" />
				</template>
			</el-table-column>
			<template v-if="showPrio">
				<el-table-column width="50" align="center" prop="prio" label="Prio" >
				</el-table-column>
				<el-table-column width="150" label="Label" >
					<template v-slot="{row}" >
						<span v-if="readonly || row.app == 'include'">{{row.label}}</span>
						<el-input v-else v-model="row.label" size="mini" />
					</template>
				</el-table-column>
			</template>
			<el-table-column  label="Acción" >
				<template v-slot="{row}">
					<template v-if="readonly">
						<b > {{row.app}}(</b><span class="font-fixed" >{{row.params}}</span><b>)</b>
				</template>
					<dialplan-action v-else v-model="row.app" :params.sync="row.params" :commands="availableCommands" />
				</template>
			</el-table-column>
			<!-- <el-table-column   label="Parámetros" >
				<template v-slot="{row}">
					<span class="font-fixed" v-if="readonly">{{row.params}}</span>
					<el-input v-else v-model="row.params"  class="font-fixed"  size="mini" />
				</template>
			</el-table-column> -->
			<el-table-column  width="80" label="" >
				<template v-slot="{$index}">
					<el-button class="boton-tabla" type="danger" size="mini" icon="el-icon-remove-outline"  @click="context.splice($index,1)" title="Eliminar Linea"></el-button>
					<el-button class="boton-tabla" type="primary" size="mini" icon="el-icon-circle-plus-outline" @click="insertarPrioridad($index)" title="Insertar Linea" ></el-button>
					</template>
			</el-table-column>
			<template slot="empty">
					<el-button cirle size="small" type="primary" icon="el-icon-circle-plus-outline" @click="insertarPrioridad(0)" title="Insertar Linea" ></el-button>
			</template>
		</el-table>

	</div>
</template>
<script>
import dialplanAction from './dialplan-action'

export default {
	components: {
		dialplanAction
	},
	props: {
		value: Array,
		showGeneratedFields: {
			type: Boolean,
			default: false
		},
		raw: Boolean,
		readonly: Boolean,
		showExten: {
			type: Boolean,
			default: true,
		},
		showPrio: {
			type: Boolean,
			default: true,
		},
		availableCommands: {
			type: Array,
			default() {
				return []
			}
		}
	},
	watch:{
		value:{
			immediate: true,
			handler(v) {
				this.stopPropagation = true
				
				this.context = v ? this.parseContext(v) : []
			}
		},
		context:{
			deep:true,
			handler(v) {
				if(this.stopPropagation) {
					this.stopPropagation = false
					return
				}
				const contextData = this.generateContext(v)
				this.$emit("input",contextData)
			}
		},
	},
	computed: {
		contextRaw: {
			get() {
				return this.value ? this.value.join('\n') :[]
			},
			set(v) {
				this.$emit("input",v.split('\n'))
			}
		},

	},
	methods: {
		/**
		 * convierte un contexto de asterisk desde texto a un array de elementos compatible con la tabla
		 */
		parseContext(v) {
			let res = []
			if(!v) {
				return res
			}
			for (const linea of v) {
				const partes = linea.split(/=>?/i)
				if(partes.length < 2) {
					continue
				}
				const v = partes.shift().trim()
				const value = partes.join('=').trim()
				let exten, prio, payload, app = "", params = "", label = ""

				switch(v) {
					case 'include':
						app=v
						params = value
						break;
					default:
						{
							const extParts = value.split(',')
							exten = extParts.shift()
	
							const partesLabel = exten.match(/(.+)\s*\((.+)\)/)
							if(partesLabel) {
								exten = partesLabel[1]
								label = partesLabel[2]
							}
	
							if(exten != 'n') {
								prio = extParts.shift()
								const partesLabel = prio.match(/(.+)\((.+)\)/)
								if(partesLabel) {
									prio = partesLabel[1]
									label = partesLabel[2]
								}
							} else {
								prio = 'n'
								exten= null
							}
							payload = extParts.join(',')
							const found = payload.match(/^\s*([\w+_]+)\s*\((.*)\s*\)/)
							if(found) {
								app = found[1] || ""
								params = found[2] || ""
							}
						}
						break;
				}

				res.push({
					// var: v,
					exten,
					prio,
					label,
					app,
					params,
				})
			}
			return res
		},

		/**
		 * convierte el array de elementos del contexto actual a un array de strings
		 */
		generateContext(data) {
			let res = []

			for(const i in data) {
				const c = data[i]
				if(c.app == 'include') {
						res.push(`include=${c.params}`)
				} else {
					if(c.exten == 'n' || !c.exten) {
						res.push(`same=>n` + (c.label ? `(${c.label})` : '')  + `,${c.app}(${c.params})`)
					} else {
						res.push(`exten=>${c.exten},1` + (c.label ? `(${c.label})` : '')  + `,${c.app}(${c.params})`)
					}
				}
			}
			return res
		},
		onDelete() {
		},
		agruparColumnaExten() {
			if(!this.showExten ) {
				return
			}

		},
		insertarPrioridad(index) {
			index++
			this.context.splice(index,0,{
				app: "",
				label: "",
				params: ""
			})
		},
	},
	data() {
		return {
			stopPropagation: false,
			context: [],
			options: [],

			exten: 's',
			loading: false,
		}
	}
	
}
</script>
<style lang="css" scoped> 

</style>
<style lang="css" >
 .el-textarea {
	font-family:monospace
 }
.dialplan-exten-row td {
		padding: 2px 0
 }

.boton-tabla {
	margin: 0;
	padding: 4px !important;
}
</style>